local funcs

//wall driving, started by lighto and finished and touched up a lot by Haya, he did a excellent job on it
local function managewallmode_post(p)
	// evil wall logic: TWO!
	local pmo = p.mo
	local hp = pmo.halfpipe
	if not hp.wallmode then return end

	// Drifting sound
	// Start looping the sound now.
	if (leveltime % 50 == 0 and p.kartstuff[k_drift] ~= 0) then
		S_StartSound(pmo, sfx_drift)
	// Leveltime being 50 might take a while at times. We'll start it up once, isntantly.
	elseif not S_SoundPlaying(pmo, sfx_drift) and p.kartstuff[k_drift] ~= 0 then
		S_StartSound(pmo, sfx_drift)
	// Ok, we'll stop now.
	elseif p.kartstuff[k_drift] == 0 then
		S_StopSoundByID(pmo, sfx_drift)
	end
	// shit!!!!!
	funcs.kansaiDurifto(p)
	-- Drifting Left - S_KART_DRIFT1_L
	if p.kartstuff[k_drift] > 0 then
		if not (pmo.state >= #states[S_KART_DRIFT1_L] and pmo.state <= #states[S_KART_DRIFT2_L]) then
			pmo.state = S_KART_DRIFT1_L
		end
	-- Drifting Right - S_KART_DRIFT1_R
	elseif p.kartstuff[k_drift] < 0 then
		if not (pmo.state >= #states[S_KART_DRIFT1_R] and pmo.state <= #states[S_KART_DRIFT2_R]) then
			pmo.state = S_KART_DRIFT1_R
		end
	end
	if p.wallspeed > 4*FRACUNIT then
		// lmaower
		local turnval = FixedAngle(FixedDiv(funcs.getTurnValue(p, p.cmd.driftturn)<<16, 200<<16))
		p.wallangle = $ + turnval
	end
	// here comes the value calculations
	// thanks lighto for doing this for me
	local wang = hp.curline.angle
	pmo.momx = FixedMul(FixedMul(p.wallspeed, cos(wang)), cos(p.wallangle))
	pmo.momy = FixedMul(FixedMul(p.wallspeed, sin(wang)), cos(p.wallangle))
	pmo.momz = FixedMul(p.wallspeed, sin(p.wallangle))

	// just for wallmode
	// sorry non saturn users. you'll get a better indicator next time
	if pmo.rollangle ~= nil then
		pmo.rollangle = (p.wallangle - ANGLE_90)
		// pmo.rollmodel = true
		// As of Saturn v6+
		if pmo.pitch ~= nil then
			pmo.pitch = ANGLE_45
		end
	end
end

local function managewallmode(p)
	local pmo = p.mo
	local hp = pmo.halfpipe
	// evil wall logic movement: TWO!
	if not hp.wallmode then return end

	// no gravity, because fuck you
	pmo.flags = $ | MF_NOGRAVITY
	// allow usage of speed items
	funcs.handleItems(p, pmo)
	// apply friction regardless!!!!!!!!
	p.wallspeed = FixedMul($ + funcs.ThreedKartMovement(p, p.cmd), pmo.friction)
	// fuck you
	pmo.angle = hp.restrictedangle
end

/*
basic function that checks collision with half pipe lines
and calculates basic information
this is a barebones basic half pipe implementation to be used by people

it uses given coordinates (not z)
a range to look for lines
the type of collision (distance from line point, points in different side of the line)
lines to ignore, can be one single line, a table with lines, ro a table with other tables that has line on it (just in case)
the obejct subjected to half pipe
this calculates the difference betwen the wall and object moving angle
it normalized betwen 1, and RRACUNIT to make usage easier
it also does calculates if the obejct is moving agains or alongside the line
to decide if it should half pipe or not
mappers can check line flags to change behaviour
*/
local function localchecklinecollision(x, y, range, collisiontype, ignore, mobj, inair)
	local test = funcs.gethalfpipeline(x, y, collisiontype, range, ignore)
	if not test then
		//try a higher range
		test = funcs.gethalfpipeline(x, y, collisiontype, range + 32*FRACUNIT, ignore)
	end

	//if doesnt find naything still, F
	if not test then return end

	//will be sued to place the object near the half pipe line
	local point = funcs.pointonline(x, y, test.wall)
	local lineflag = test.wall.flags

	local ignoreslope = lineflag & ML_EFFECT1 // Slope Skew
	local ignoreangle = lineflag & ML_NOKNUX // No Knuckles

	local momoveangle = R_PointToAngle2(0, 0, mobj.momx, mobj.momy)
	local angdiff = abs(funcs.angletoint(momoveangle) - funcs.angletoint(test.back)) % 360
	if angdiff > 180 then
		angdiff = 360 - $
	end
	if angdiff == 0 then angdiff = 1 end //avoiding errors here

	//those doesnt count of youre in the air already
	if not inair then
		//must be o nthe gloor
		//oooooorr must be on a slope, that goes up (deoending on the gravity direction)
		if not ignoreslope and not (P_IsObjectOnGround(mobj) and mobj.standingslope) then return end
		if not ignoreslope and mobj.standingslope and not ignoreangle then
			if P_MobjFlip(mobj) > 0 then
				if funcs.angletoint(mobj.standingslope.zangle) < 32
				or funcs.angletoint(mobj.standingslope.zangle) > 360 - 32 then return end
			else
				if abs(funcs.angletoint(mobj.standingslope.zangle) - 180) < 32 then return end
			end
		end

		//big deny fest
		if not ignoreangle and angdiff > 80 then return end
	end

	//deliver the angle difference normalize
	//gives a value ebtwen 1 and ANG1
	angdiff = FixedDiv(abs(momoveangle - test.back) - 1 ,(64)*ANG1 - 1) // FixedDiv((momoveangle - test.back) - 1, (FixedAngle(80*FRACUNIT) - 1))
	if angdiff == 0 then angdiff = 1 end //avoiding errors here

	return {
		line = test,
		point = point,
		angdiff = angdiff,
		nogravity = lineflag & ML_EFFECT2, // No Midtexture Skew
		landonceiling = lineflag & ML_EFFECT3, // Peg Midtexture
		wallmode = (lineflag & ML_EFFECT4) or (lineflag & ML_NOSONIC), // Solid Midtexture
		forcedetach = lineflag & ML_EFFECT5, // Repeat Midtexture
		forceangle = lineflag & ML_NOTAILS, // No Tails
		ignoreslope = ignoreslope,
	}
end

/*
function that launches the obejct for the half pipe
from here theres no return point, everything is calculated before by another function
sets some of the objects fields to keep track of behaviours and its state
*/
local function locallaunchtohalfpipe(mo, data)
	local hspeed = FixedHypot(mo.momx, mo.momy)
	local hspdcap = data.line.wall.frontside.textureoffset
	local vspdcap = data.line.wall.frontside.rowoffset
	local momoveang = R_PointToAngle2(0, 0, mo.momx, mo.momy)

	hspeed = min($, hspdcap or hspeed)
	local vspeed = min(hspeed, vspdcap or hspeed)

	local hp = mo.halfpipe

	hp.movedir = momoveang - data.line.back < 0 and 1 or -1
	hp.horispeed = FixedMul(hspeed, data.angdiff) * hp.movedir
	hp.vertspeed = 8*FRACUNIT + FixedMul(vspeed, 2048+FRACUNIT - (data.angdiff - (data.angdiff/6))) * P_MobjFlip(mo)

	//smol hack to work around slope physics
	mo.flags = $ | MF_NOCLIPHEIGHT

	hp.restrictedangle = mo.angle
	data.point.x = $ + FixedMul(mo.radius + 9*FRACUNIT, cos(data.line.front))
	data.point.y = $ + FixedMul(mo.radius + 9*FRACUNIT, sin(data.line.front))
	P_TryMove(mo, data.point.x, data.point.y, true)

	mo.flags = $ & ~MF_NOCLIPHEIGHT

	local floor
	if P_MobjFlip(mo) > 0 then floor = mo.floorz else floor = mo.ceilingz end
	if data.ignoreslope then
		mo.z = $ + (-P_GetMobjGravity(mo)*2) //move off the ground like its been 2 frames in game
	else
		mo.z = floor + (-P_GetMobjGravity(mo)*2) //move off the ground like its been 2 frames in game
	end

	P_InstaThrust(mo, data.line.angle, hp.horispeed)
	mo.momz = hp.vertspeed

	hp.nogravity = data.nogravity
	hp.landceiling = data.landonceiling
	hp.detach = data.forcedetach
	hp.wallmode = data.wallmode
	hp.curline = data.line
	hp.prevline = data.line
	hp.forceangle = data.forceangle

	if hp.wallmode and mo.player then
		//update your speed rn
		mo.player.wallspeed = mo.player.speed
		// is it really this fucking simple???? damn then
		mo.player.wallangle = mo.angle - data.line.angle
		P_InstaThrust(mo, data.line.angle, 0)
	end

	hp.launched = true
	hp.launchcd = 3

	if hp.forceangle then mo.angle = data.line.angle end
	if hp.nogravity then mo.flags = $ | MF_NOGRAVITY end
end

/*
functio nthat resets everything related to half pipe to be ready for the next time
*/

local function localhalfpipedeatch(mo)
	local hp = mo.halfpipe
	if hp.wallmode and mo.player and P_IsObjectOnGround(mo) then
		P_InstaThrust(mo, mo.player.wallangle-ANGLE_90, 32*FRACUNIT)
	end
	if hp.nogravity or hp.wallmode then
		mo.flags = $ & ~MF_NOGRAVITY
		if mo.rollangle ~= nil then
			mo.rollangle = 0
		end
		// As of Saturn v6+
		if mo.pitch ~= nil then
			mo.pitch = 0
		end
	end
	hp.launched = false
	hp.curline = false
	hp.prevline = false
	hp.wallmode = false
	hp.nogravity = false
	hp.landceiling = false
	hp.detach = false
	hp.zmom = 0
	hp.launchcd = 3
	hp.landcd = 3
	hp.forceangle = false
end

/*
function to switch betwen half pipe lines when launched by one already
it wont switch for the same line or the previous
it als owont switch if not close enough
it does not account for angle difference, neither detaches if no line is found
*/
local function localswitchhalfpipeline(mo, data)
	local hp = mo.halfpipe
	local hspeed = FixedHypot(mo.momx, mo.momy)
	local hspdcap = data.line.wall.frontside.textureoffset
	local momoveang = R_PointToAngle2(0, 0, mo.momx, mo.momy)

	hspeed = min($, hspdcap or hspeed)

	hp.movedir = (momoveang - data.line.back) < 0 and 1 or -1
	hp.horispeed = hspeed * hp.movedir

	P_InstaThrust(mo, data.line.angle, hp.horispeed)

	mo.flags = $ | MF_NOCLIPHEIGHT

	data.point.x = $ + FixedMul(mo.radius + 9*FRACUNIT, cos(data.line.front))
	data.point.y = $ + FixedMul(mo.radius + 9*FRACUNIT, sin(data.line.front))
	P_TryMove(mo, data.point.x, data.point.y, true)

	mo.flags = $ & ~MF_NOCLIPHEIGHT

	hp.nogravity = data.nogravity
	hp.landceiling = data.landonceiling
	hp.detach = data.forcedetach
	hp.forceangle = data.forceangle

	hp.prevline = hp.curline
	hp.curline = data.line

	if hp.forceangle then mo.angle = data.line.angle end
	if hp.nogravity then mo.flags = $ | MF_NOGRAVITY end
end

/*
allows to set/change some effects related to half pipes
use more liendef flags for more variety of effects
*/
addHook("LinedefExecute", function(line, mobj, sector)
	if not mobj then return end
	local hp = mobj.halfpipe

	if line.flags & ML_EFFECT2
	and hp.launched then //No Midtexture Skew
		//YKNOW theres the vanilla trigger. but the var
		hp.nogravity = true
		mobj.flags = $ & ~MF_NOGRAVITY
	end

	if line.flags & ML_EFFECT3 then //Peg Midtexture
		hp.landceiling = true
	end

	if line.flags & ML_EFFECT4 then //Solid Midtexture
		hp.wallmode = true
		//call wall mode functions here
	end

	if line.flags & ML_EFFECT5 then //Repeat Midtexture
		hp.detach = true
	end

	//set delay (in tics) to wait for to be launched again
	if line.frontside.textureoffset ~= 0 then
		hp.launchcd = abs(line.frontside.textureoffset)/FRACUNIT
	end

	//give a thrusto to the object if in half pipe mode
	if hp.launched then
		//owith this flag affects horizontal speed
		if line.frontside.rowoffset ~= 0
		and line.flags & 8 then //upper unpegged
			//invert current speed
			if line.frontside.rowoffset == FRACUNIT then
				P_Thrust(mobj, hp.curline.angle, FixedHypot(mobj.momx, mobj.momy)*-1)
			else
				//set specific speed
				P_Thrust(mobj, hp.curline.angle, line.frontside.rowoffset)
			end

		end

		//with this flag affects vertical speed
		if line.frontside.rowoffset ~= 0
		and line.flags & 16 then //lower unpegged
			if line.frontside.rowoffset == FRACUNIT then
				//invert speed
				mobj.momz = $ *-1
			else
				//set specific speed
				mobj.momz = $ + line.frontside.rowoffset
			end

		end
	end
end, "HALFPIPE")

local molist = {MT_PLAYER, MT_ORBINAUT, MT_JAWZ}
local shouldrun = false

addHook("MapLoad", do
	shouldrun = hp_runhalfpipelua
	if shouldrun then funcs = HalfPipe.funcs end
end)
addHook("NetVars", function(net)
	shouldrun = net($)
	if shouldrun then funcs = HalfPipe.funcs end
end)

for i = 1, #molist do
addHook("MobjThinker",function(mo)
	if not shouldrun then return end //F
	local hp = mo.halfpipe
	if not hp then
		hp = setmetatable({
			launched = false, //let you know if your got launched into a halfpipe
			curline = false, //current halfpipe line
			prevline = false, //previous half pipel ine to prevent bugs also let do some calcs
			zmom = 0, //keeps your vertical momentum while in the half pipe, to use when landing
			landcd = 0, //note: unused //waits this delay counter to reach 0 to let you get launched again
			launchcd = 0, //wait for some frames to launch you up, tring interopability here
			vertspeed = 0,
			horispeed = 0,
			movedir = 0, //which direction we will move (-1 or 1)
			wallmode = false,
			nogravity = false,
			landceiling = false,
			detach = false,
			forceangle = false,
			restrictedangle = 0,
		}, {
			__index = function(_, k) error("attempt to read "..tostring(k), 2) end,
			__newindex = function(_, k) error("attempt to write "..tostring(k), 2) end
		})
		mo.halfpipe = hp
	end
	local speed = FixedHypot(mo.momx, mo.momy)
	local search = localchecklinecollision(mo.x, mo.y, speed + mo.radius + 16*FRACUNIT, 1, {hp.curline or nil, hp.prevline or nil}, mo, hp.launched)

	//land on the ceiling
	if hp.launched and (search and search.landonceiling or hp.landceiling)
	and ((P_MobjFlip(mo) > 0 and mo.z + mo.height >= mo.ceilingz)
	or (P_MobjFlip(mo) < 0 and mo.z <= mo.floorz)) then	
		mo.flags2 = $ & ~MF2_OBJECTFLIP
		mo.eflags = $ & ~MFE_VERTICALFLIP
		if hp.wallmode and mo.player then
			mo.flags = $ & ~MF_NOGRAVITY
			// just for wallmode
			// sorry non saturn users. you'll get a better indicator next time
			if mo.rollangle ~= nil then
				mo.rollangle = 0
			end
		end
	end

	//land
	//forcefully detach
	if (P_IsObjectOnGround(mo) and hp.launched and hp.launchcd <= 0)
	or (search and search.forcedetach or hp.detach)
	or hp.wallmode and (hp.curline and hp.curline.wall.backsector and mo.z > hp.curline.wall.backsector.floorheight)
	or i == 1 and (hp.curline and mo.player and mo.player.kartstuff[k_spinouttimer]) then
		//normal landing
		//change angle (looking direction)
		//add some speed when landing on slopes
		if P_IsObjectOnGround(mo) and not (search and search.forcedetach or hp.detach) and not hp.wallmode then
			if not search then //youre in the same line you got launched
				if abs(hp.horispeed) < 2*FRACUNIT then
					//reverse 180 since you didnt move horizontally
					local ang = hp.curline.front
					mo.wallthrustangle = ang
				else
					local ang = hp.curline.front - (84*ANG1 * -hp.movedir)
					//adjust your angle to the wall so the camera displays were you going
					//if mo.angle-ang < ang then
						mo.wallthrustangle = ang
					//end
				end
				//in this scenario what we want is to revert the abgle
				//or else the object wil ldeccelerate
				if hp.landceiling then
					//"loops"
					mo.wallthrustangle = hp.curline.front
				elseif (search and search.landonceiling) then
					mo.wallthrustangle = search.line.front
				end
			end
			if hp.forceangle then
				mo.angle = mo.wallthrustangle
			end
			if mo.standingslope and mo.wallthrustangle then
				P_Thrust(mo, mo.wallthrustangle, abs(hp.zmom)/2)
			end
		end
		//detach
		//if a line is marked to detach or yo uset via linedef trigger
		if (search and search.forcedetach or hp.detach) and hp.launched and not hp.wallmode and hp.forceangle then
			mo.angle = hp.curline.front - (84*ANG1) * -hp.movedir
		end
		//unset some stuff
		localhalfpipedeatch(mo)
	end

	//launch
	if search then
		//common first launch
		if hp.launchcd <= 0
		and not hp.launched
		and (P_IsObjectOnGround(mo) or not search.ignoreslope)
		and not (search.forcedetach or hp.detach)
		and not (i == 1 and (mo.player and mo.player.kartstuff[k_spinouttimer])) then
			//proceed normally to launch to half pipe
			locallaunchtohalfpipe(mo, search)
		end

		//switch to another half pipe line instead
		if hp.launched
		and FixedHypot(
			mo.x - (search.point.x + FixedMul(mo.radius + 9*FRACUNIT, cos(search.line.front))),
			mo.y - (search.point.y + FixedMul(mo.radius + 9*FRACUNIT, sin(search.line.front)))
		) < 9*FRACUNIT + speed + FRACUNIT then
			//checks if youre close enough to switch to the enxt line
			//so the obejct does not bonk on obstacles for trying to seitch too early
			localswitchhalfpipeline(mo, search)
		end

	end

	//manage wall mode
	//that was started by me but totally finished by Haya, he did a lot more on it and its awesome

	if mo.player and hp.wallmode then
		managewallmode(mo.player)
	end

	if hp.launched then
		//adjust camera by chaning object angle (the player)
		if hp.horispeed ~= 0 and i == 1 and not hp.wallmode and hp.forceangle then
			mo.angle = hp.curline.back + (ANGLE_45 * -hp.movedir)
		end

		//store's player speed mdiair to use when landing
		hp.zmom = mo.momz
		if hp.nogravity then
			hp.zmom = hp.vertspeed
		end
	end
	hp.launchcd = max(0, $ - 1)
end,molist[i])
end

addHook("PostThinkFrame", function()
	if not shouldrun then return end //F
	for p in players.iterate do
		if not p.spectator then managewallmode_post(p) end
	end
end)
