//zipline lua by Lighto

//this will be done with linedefs executors, becuz yes
//the liendef angle will be the ziipline angle
//the lenght will be the speed
freeslot("MT_ZIPLINE", "SPR_LZPT","S_LTB_ZIPLINETETHER")

mobjinfo[MT_ZIPLINE] = {
	--$Name Zipline Point
	--$Sprite LZPE0
	--$Flags1Text No Gravity Force
	--$Flags4Text Pogo spring effect
	--$Flags8Text Hang from top
	--$AngleText Group/point id
    doomednum = 2945,
    spawnstate = S_INVISIBLE,
    raisestate = S_INVISIBLE,
    spawnhealth = 1000,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    mass = 0,
    damage = 0,
	speed = 0,
    flags = MF_NOCLIP|MF_NOGRAVITY

}
states[S_LTB_ZIPLINETETHER] = {SPR_LZPT, FF_ANIMATE, -1, nil, 5, 2, S_NULL}
local ziplist = {}

local objlist = {}

local buildziplinetable, setzipfunc, lookzipline, ziplinelinedraw, ziplinelogic,safetychecks, itemthroeinteract, stuffreset, linedefcustom, exitzipline, enterzipline, setanglelerp, ziplinewind, playerziplineexplode, playerziplinesquish, playerzipdamage, ziplinecollide,momentumtransfer
//custom liendef trigger stuff below
local ziplineminspeed, ziplinemaxspeed, ziplineverticaloffset, ziplinecolor, finishpogospring, zipbackenterrange, zipfrontenterrange, dontconnect, dontturn, hastobeonground, onlyentersides = 16*FRACUNIT, 45*FRACUNIT, 0, 0, 0, 45, 75, nil,nil, nil, nil

local objlistbackup 

//self explanatory
local function angletoint(a)
	a = FixedInt(AngleFixed(a))
	if a < 0 then a = $ + 359 end
	return a
end

//angle difference that wont go above 180 and is always positive
local function angledifference(a,b)
	a = angletoint($)
	b = angletoint($)
	return 180 - abs(abs(a - b) - 180)
end


local groupcount = 0
//adds the points to a table, sort by group, each group sorts its points by their internal id's
//YOU CAN skip groups, do not recommends but it can happen sometimes 
function buildziplinetable(mo)
	if not(mo and mo.valid) or not mo.spawnpoint then return end
	local group, id = (mo.spawnpoint.angle / 360) + 1
	id = (mo.spawnpoint.angle - (360 * (group - 1))) 
	if group > groupcount then groupcount = group end //to keep track of the highest group id
	if not ziplist[group] then ziplist[group] = {} end
	//mo.z = $ + 8*FRACUNIT
	table.insert(ziplist[group], {x=mo.x ,y=mo.y ,z=mo.z, id=id, group=group, flags = mo.spawnpoint.options, grp = group, opt = mo.spawnpoint})
	table.sort(ziplist[group],function(a,b) return a.id < b.id end)
	LTB_ziplines.ziplinelist = ziplist
	P_RemoveMobj(mo)
end

//had to appeal to this, but now it works perfectly fine
local function lerp(a,b,t)
	return a + FixedMul(b - a, t)
end

//set how long the object will take to change its angle , so its not a sudden snap
function setanglelerp(oa, na, leng, mo)
	mo.LTB_oldangle = oa
	mo.LTB_targetangle = na
	mo.LTB_angleturnspeed = FixedDiv(FixedAngle(angledifference(oa,na)*FRACUNIT/(TICRATE*2)), leng) //FixedDiv(FRACUNIT ,abs(mo.angle - mo.LTB_ziphoriang))
	mo.LTB_angleturn = 1
end

//this sets the variables to start the zipline movement
//it also does when switching points/segments
function enterzipline(a, b, mo, group, id)
	//store possible old zpline refference if theres any
	local lenght, distfroma, oldzipprog, oldzipspd, oldziplen, oldhoriang = FixedHypot(a.x - b.x, a.y - b.y), FixedHypot(a.x - mo.x, a.y - mo.y), mo.LTB_zipprogress, mo.LTB_zipspeed or 16, mo.LTB_disttonext, mo.LTB_ziphoriang or mo.angle
	mo.LTB_inzipline = true //start the zipline action
	mo.LTB_zipgroup = group //remember the group youre in
	mo.LTB_zipid = id //remember the id, the point you touched
	mo.LTB_zip = LTB_ziplines.ziplinelist[group] //the list of the group, to make thngs easier
	mo.LTB_disttonext = lenght
	LTB_ziplines.funcs.calculateziplinedata(a, b, mo) //this function takes the point that got touched, the next and the object
	mo.LTB_zipcooldown = TICRATE / 8 //adds a small cooldown to avoid a bug that keeps switching points extremely fast
	LTB_ziplines.funcs.setangleinterpolation(mo.angle, mo.LTB_ziphoriang, mo.LTB_disttonext, mo)	
	
	//if this variable was valid beforehand
	//it means this object is in a zipline already
	//and is likely to switch to another segment
	if oldzipprog then
		//switch to the next segment by going forward
		//if the progress is higher than FRACUNIT it means it reached the end
		if oldzipprog + FixedDiv(oldzipspd, oldziplen) >= FRACUNIT then
			local difference = abs(FRACUNIT - (oldzipprog + FixedDiv(oldzipspd ,mo.LTB_disttonext)) ) or 1
			mo.LTB_zipprogress = FixedDiv(difference, mo.LTB_disttonext)
			
			LTB_ziplines.funcs.setangleinterpolation(oldhoriang, mo.LTB_ziphoriang, mo.LTB_disttonext, mo)
		end
		//switch segment by going backwards
		//if the progress is lower than 0, it means its before the start of the segment
		if oldzipprog + FixedDiv(oldzipspd,oldziplen) <= 0 then
			if mo.LTB_zipspeed > 0 then mo.LTB_zipspeed = $ *- 1 end
			local difference = (abs(oldzipprog)+abs(FixedDiv(oldzipspd,oldziplen))) or 1
			mo.LTB_zipprogress = FRACUNIT - FixedDiv( difference ,mo.LTB_disttonext) //mo.LTB_disttonext - (mo.LTB_zipspeed) //how far we are from the lastest point, ifswitching from another point, use the previous speed
			
			if mo.LTB_goingbackawrds then
				LTB_ziplines.funcs.setangleinterpolation( mo.angle , mo.LTB_ziphoriang - ANGLE_180, mo.LTB_disttonext, mo)
			end
		end		
	else
		//this object wasnt in a zipline before and entered the end of the segment by going backwards
		//if this value is greater than half of FRACUNIT it means
		//this object entered the zipline going backwards and object is in the end of the segment
		if FixedDiv(distfroma - 1, lenght - 1) > FRACUNIT / 2 then
			if mo.LTB_zipspeed > 0 then mo.LTB_zipspeed = $ *- 1 end //invert speed if not inverted
			mo.LTB_zipprogress = FRACUNIT + FixedDiv(mo.LTB_zipspeed or 16,mo.LTB_disttonext) 
			mo.LTB_goingbackawrds = true //let it know if the object entered the zipline going backwards, so it can know if aligning the angle is desired when going backwards
			LTB_ziplines.funcs.setangleinterpolation( mo.angle , mo.LTB_ziphoriang - ANGLE_180, mo.LTB_disttonext, mo)
		end
	end				
	
end

//look for each zipline point to know if a object is close enough from the zipline
//if it does, perfom some extra checks and start the zipline logic
function lookzipline(mo)
	local zipline, current, next, previous = LTB_ziplines.ziplinelist
	for i = 1, groupcount do	
		if not zipline[i] then continue end
		local zipdist, zipvdist , frontangledif, backangledif, moveang, ziprad, zipheight
		ziprad = 32*FRACUNIT
		zipheight = 32*FRACUNIT
		
		//now look for all points of this group
		for j = 1, #zipline[i] do
			if not zipline[i][j] then continue end
			//can pnly enter from start or the end of the zipline
			if onlyentersides and j > 1 and j < #zipline[i] then continue end
			current = zipline[i][j]
			moveang = R_PointToAngle2(0,0,mo.momx, mo.momy) 
			next = zipline[i][#zipline[i]]  
			if zipline[i][j + 1] then next = zipline[i][j + 1] end
			previous = zipline[i][1] //dont let get out of range
			if zipline[i][j - 1] then previous = zipline[i][j - 1] end
			
			//special case for falling objects
			//those doesnt need to move horizontally, but can only go forward
			if FixedHypot(mo.momx, mo.momy) < 2*FRACUNIT then moveang = R_PointToAngle2(current.x, current.y, next.x, next.y) end
			
			//calculate this
			frontangledif = angledifference(moveang, R_PointToAngle2(current.x, current.y, next.x, next.y))
			backangledif =  angledifference(moveang, R_PointToAngle2(current.x, current.y, previous.x, previous.y))
			
			//this doesnt allow to go back in the first point neither forward in the last
			if j == 1 then backangledif = 180 end 
			if j == #zipline[i] then frontangledif = 180 end
			local moz, height = mo.z+min(mo.height*P_MobjFlip(mo),0), mo.height + abs(ziplineverticaloffset) //common axis
			//if the object is flipped, change to use its base/"feet"
			if P_MobjFlip(mo) then moz = $ + mo.height end
			if current.flags & 8 then --ambush
				//add a offset to use the top of the object
				//on common gravity this is the head
				//on flipped is also the ehad, that normaly would be the feet/base
				//the extra offset is flipped as well so is the same for both cases
				moz = $ + mo.height*P_MobjFlip(mo)
			end
			zipdist = FixedHypot(mo.x - current.x, mo.y - current.y)
			zipvdist = abs(moz - current.z)
			if zipdist <= mo.radius + ziprad
			and zipvdist <=  zipheight + height  then
				local succed
				//this makes it go forward, the common interaction
				//note that this is more prone ot happen than going backwards
				if frontangledif <= zipfrontenterrange then
					
					LTB_ziplines.funcs.enterzipline(current, next, mo, i, j)
					
					succed = true
				end
				//this case is less likely to happen, to avoid frustration during races
				if backangledif <= zipbackenterrange then
					//use the previous point instead
					LTB_ziplines.funcs.enterzipline(previous, current, mo, i, (j - 1) or 1)
					
					succed = true
				end	
				if succed then break 2 end //exit earlier succedful interaction
				
			end
			
		end
	end
end

//creates lines connecting the points
//dont worry about the objects, those have flags to make them  less demanding to exist
local alreadydrawn
function ziplinelinedraw()
	if alreadydrawn then return end
	alreadydrawn = true
	if dontconnect then return end //dont even bother if mapper dont want those to appear
	local zipdist
	local a,b 
	for i = 1, groupcount do
		if not LTB_ziplines.ziplinelist[i] then continue end
		for j = 1, #LTB_ziplines.ziplinelist[i] - 1 do
			if not LTB_ziplines.ziplinelist[i][j] then continue end
			a = LTB_ziplines.ziplinelist[i][j]
			b = LTB_ziplines.ziplinelist[i][j+ 1] 
			zipdist = FixedHypot(a.x - b.x, a.y - b.y)
			for k = 1, (zipdist / FRACUNIT) / 64 do
				local ref = P_SpawnMobj(
				lerp(a.x,b.x,FixedDiv((k*FRACUNIT)*64,zipdist)),
				lerp(a.y,b.y,FixedDiv((k*FRACUNIT)*64,zipdist)),
				lerp(a.z,b.z,FixedDiv((k*FRACUNIT)*64,zipdist)),MT_THOK)
				
				ref.tics = -1
				ref.fuse = -1
				ref.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING //those are the most i can do to make these eat less processing
				local zipcolor = 0
				if ziplinecolor == -1 then zipcolor = P_RandomRange(0,100) end
				if ziplinecolor > 0 then zipcolor = max(0,min(ziplinecolor,100)) end
				if ziplinecolor == 0 then 
					//all of those choosen by my ass, ofc				
					if zipdist / FRACUNIT > 840 then
						zipcolor = 84 //pearltwinkle
					end
					if zipdist / FRACUNIT > 512 then
						zipcolor = 92 //bubblegum
					end
					if zipdist / FRACUNIT < 384 then
						zipcolor = 30 //ketchup
					end
					if zipdist / FRACUNIT < 256 then
						zipcolor = 46 //wuarry
					end
					if zipdist / FRACUNIT < 128 then
						zipcolor = 3 //grey
					end
					
					
				end
				ref.color = zipcolor
				ref.scale = FixedMul(FRACUNIT,(ref.info.radius / (32))) //FixedMul(ref.info.radius,12*FRACUNIT)
				ref.scale = $ + P_RandomRange(-FRACUNIT/4, FRACUNIT/4)
				local gravflip = 1
				if a.flags & 2 then gravflip = -1 end
				if a.flags & 8 then
					ref.z = $ + FixedMul(16*FRACUNIT,FixedMul(FRACUNIT,ref.scale)) * gravflip
				else
					ref.z = $ - FixedMul(16*FRACUNIT,FixedMul(FRACUNIT,ref.scale)) * gravflip
				end
				ref.state = S_LTB_ZIPLINETETHER
				ref.frame = FF_ANIMATE|(((65 - k)*2) % 6)
				ref.isziplineline = true
				ref.zipgroup = i
				ref.zipid = j
				ref.linepointid = k //letting yall know what those are, i dunno, if someone ever wants to modify these
			end
		end
	end
end

//manages the zipline logic, moves the object and seitch points or exit the zipline logic
function ziplinelogic(mo)
	//basic movement
	mo.flags = $ | MF_NOGRAVITY //always set this to avoid issue with gravity
	mo.LTB_zipspeed  = ($ or 0) - mo.LTB_zipgravity //add the gravity force to the zipline speed, thus creating some intertia effect
	//force momentum so its like a common movement, so other code and mods has less chance of brwaking
	//and if something ever goes wrong, the object will be teleported back to the place it should be
	P_InstaThrust(mo,mo.LTB_ziphoriang, mo.LTB_zipspeed  )
	mo.momz = FixedMul(mo.LTB_zipspeed ,sin(mo.LTB_zipvertang))
	
	//lerp angle to the zipline angle (if desired to do it so)
	if mo.LTB_angleturn
	and mo.LTB_angleturn < FRACUNIT
	and not dontturn then
		mo.angle = lerp((mo.LTB_oldangle), (mo.LTB_targetangle), mo.LTB_angleturnspeed)
		mo.LTB_angleturn = $ + mo.LTB_angleturnspeed
	end
		
	
	if mo.LTB_zipspeed == 0 then mo.LTB_zipspeed = 2 end //trying to avoid divide by 0 errors
	if mo.LTB_disttonext == 0 then mo.LTB_disttonext = 4 end
	if mo.LTB_zipprogress == 0 then mo.LTB_zipprogress = 8 end
	//its a normalized value, ranging from 0 to FFRACUNIT
	//adding the divided zipline speed by the length to be travelled, so it can be used in a letp formula
	//its basically the calculation to figure out how long it would take to travel from a to b using this speed
	mo.LTB_zipprogress = $ + FixedDiv(mo.LTB_zipspeed ,mo.LTB_disttonext) //how far the object is from the starting point
	
	//using try move to make sure anything bad happens midway through
	P_TryMove(mo,
	lerp(mo.LTB_origin.x, mo.LTB_dest.x, mo.LTB_zipprogress),
	lerp(mo.LTB_origin.y, mo.LTB_dest.y, mo.LTB_zipprogress),
	true)
	
	//thats probably fine , i hope....
	mo.z = lerp(mo.LTB_origin.z + mo.LTB_verticaloffset, mo.LTB_dest.z + mo.LTB_verticaloffset, mo.LTB_zipprogress)
	
	//point switching goes here
	//it takes care of changing the points to keep sliding the zipline
	//it can go forward or backwards
	//either get off the zipline if going to the end or to the start of it
	
	local speed, start, destination, nextpoint, normalizedspeed = mo.LTB_zipspeed, mo.LTB_zip[mo.LTB_zipid]
	normalizedspeed = FixedDiv(mo.LTB_zipspeed ,mo.LTB_disttonext) //is easier to have that in a var
	if not normalizedspeed then normalizedspeed = 8 end
	//first logic if going forwad
	if speed > 0 then
		//check if this object travelled the whole lenght it should for this point
		//remember, is a normalized value so FRACUNIT is the end
		if mo.LTB_zipprogress + normalizedspeed 
		> FRACUNIT  and not mo.LTB_zipcooldown then //adding the speed so it does not overshoot the target too much
			//now this is a bit little complicated to explain
			//the destination is the start's id + 1
			//we check if theres is another point after the destination
			//which would be start's id + 2
			//that would be, another segments after this one already finished
			if mo.LTB_zip[mo.LTB_zipid + 2] then //this is the NEXT point AFTER the destination
				
				start = mo.LTB_zip[mo.LTB_zipid + 1]
				destination = mo.LTB_zip[mo.LTB_zipid + 2]
				
				
				mo.LTB_zipid = $ + 1 //increase the id to the point that got reached
				LTB_ziplines.funcs.enterzipline(start, destination, mo, mo.LTB_zipgroup, mo.LTB_zipid)
				
				if mo.LTB_zipid == mo.LTB_lastestpoint then
					//since its possible to go backwards, keep track of the previous point
					//so if the object is going back and forth in the same point, it can be saved
					mo.LTB_ziplinesafety = ($ or 0) + 1
				end				
				mo.LTB_lastestpoint = mo.LTB_zipid - 1  //since it already got added by one, decrease it back
			else
				//exit the zipline and get launched
				LTB_ziplines.funcs.exitzipline(mo)
			 
			end
			
		end
	else //going backwards on the zipline
		if mo.LTB_zipprogress + normalizedspeed 
		< 0 and not mo.LTB_zipcooldown then //speed is already negative so it subtracts here, and progress should be below 0
			//if it is below 0 it means the object is to the other side of the point
			//which also means it can switch to the previous point, iv theres one
			//when i say previous, is the point that comes before the current one being used as refference
			
			//now check if this is the start of the zipline by looking if the current point is the first one
			if mo.LTB_zipid == 1 then //it is inded the start of the zipline, so this means if you go behind the starting point, you leave the zipline
				LTB_ziplines.funcs.exitzipline(mo) //bye
			
			else
				//its a little tricky as the code to enter the zipline and go backwards
				//get the information and then add the distance to already be in the end of the previous section lenght
				destination = mo.LTB_zip[mo.LTB_zipid - 1] //where we want to go, the previous one
				start = mo.LTB_zip[mo.LTB_zipid ] //basicaly, this point, the one being touched/passed by
				mo.LTB_zipid = $ - 1 //decrease that so we know which point is being used
				
				LTB_ziplines.funcs.enterzipline(destination, start, mo, mo.LTB_zipgroup, mo.LTB_zipid)
				
				if mo.LTB_zipid == mo.LTB_lastestpoint then
					//since its possible to go backwards, leep track of the previous point
					//so if the object is going back and forth in the same point, it can be saved
					mo.LTB_ziplinesafety = ($ or 0) + 1
				end
				
				mo.LTB_lastestpoint = mo.LTB_zipid + 1 //use this to keep track if stuck in one point, add one back since it get subtracted by one

			end
		end
	end
end

//exists the zipline keeping momentum
function exitzipline(mo)
	mo.LTB_inzipline = nil //bye
	mo.flags = $ & ~MF_NOGRAVITY //undo that
	
	//convert the zipline speed onto the object momentum
	//add pogo spring state if desired
	if mo.player then mo.player.kartstuff[k_pogospring] = finishpogospring end 
	P_InstaThrust(mo, mo.LTB_ziphoriang, FixedMul(mo.LTB_zipspeed,cos(mo.LTB_zipvertang))) //dont need to do any conversion here
	mo.momz = FixedMul(mo.LTB_zipspeed,sin(mo.LTB_zipvertang)) //P_ReturnThrustY(nil,mo.LTB_zipvertang, mo.LTB_zipspeed) //THIS IS STILL OFF, but what I can do
	if mo.LTB_zipspeed > 0 then
		mo.angle = mo.LTB_ziphoriang 
		mo.dir = mo.LTB_ziphoriang 
		mo.movedir = mo.LTB_ziphoriang	
	end
	mo.LTB_zipspeed = nil
	mo.LTB_zipprogress = nil
	mo.LTB_disttonext = nil
	mo.LTB_zipcooldown = TICRATE/4 // one second cooldown to go ziplining again, to avoid bugs
	mo.LTB_lastestpoint = 0 //reset that to avoid erroneous counting
	mo.LTB_ziplinesafety = 0 //you left the zipline so reset this
	mo.LTB_goingbackawrds = nil
	mo.LTB_targetangle = nil
	mo.LTB_angleturnspeed = nil
	mo.LTB_angleturn = nil
end

function safetychecks(mo)
	if mo.LTB_ziplinesafety
	and mo.LTB_ziplinesafety == 2 then
		mo.LTB_zipspeed = P_ReturnThrustY(nil,mo.LTB_zipvertang, 64*FRACUNIT) //give it a strong forward thrust if the object is going back and forth
		mo.LTB_ziplinesafety = 3 //set this so if it happens agains, its over
	elseif mo.LTB_ziplinesafety
	and mo.LTB_ziplinesafety > 3 then
		exitzipline(mo)
	end
end


//set custom minimum and top speed for the ziplie
function linedefcustom(line,  mobj,  sector)
	local flags = line.flags
	ziplineminspeed = line.frontside.textureoffset or $
	ziplinemaxspeed = line.frontside.rowoffset or $
	if line.backside then ziplineverticaloffset = line.backside.textureoffset end
	if line.backside then ziplinecolor = (line.backside.rowoffset / FRACUNIT) end
	
	//force yellow or red pogo spring state on zipline exit
	finishpogospring = 0  
	//if flags & 16 then finishpogospring = 1 end // Lower Unpegged
	//if flags & 32 then finishpogospring = 2 end //Slope Skew 	
	//do not change the object angle at all (minus the exit)
	dontconnect = nil
	if flags & 64 then dontconnect = true end //Not Climbable  
	//same angle range for both cases
	if flags & 128 then //No Midtexture Skew 
		zipbackenterrange, zipfrontenterrange = 75, 75
	end
	
	//you can only enter a xipline, if driving o ngroup
	hastobeonground = flags & 256 //Peg Midtexture 
	
	//cant enter a zipline from others poitns if not the end or the start of it
	onlyentersides = flags & 512 //solid midtezture
	
	//print("finishpogospring "..finishpogospring)
	//print("dontconnect "..dontconnect)
	//print("zipbackenterrange "..zipbackenterrange)
	//print("hastobeonground "..hastobeonground)
	//print("onlyentersides "..onlyentersides)
	
end

function itemthroeinteract(mo)
	local moveang, angfrontdiff, angbackdiff = R_PointToAngle2(0,0,mo.momx, mo.momy)
	if mo.type ~= MT_PLAYER 
	and not mo.LTB_inzipline 
	and not mo.LTB_throwhooked
	and mo.LTB_otherslife <= TICRATE / 6 then
		if mo.target
		and mo.target.player
		and mo.target.LTB_inzipline then
			local p, pmo = mo.target.player, mo.target
			angfrontdiff = angledifference(moveang,pmo.LTB_ziphoriang)// abs(abs(AngleFixed(moveang)) - abs(AngleFixed(mo.target.LTB_ziphoriang)))
			angbackdiff =  angledifference(moveang,pmo.LTB_ziphoriang-ANGLE_180)
		  
			//this is done manually to prevent issues
			if angfrontdiff <= 42 then
				//use the thrower information
				mo.LTB_inzipline = true //start the zipline action
				mo.LTB_zipgroup = pmo.LTB_zipgroup //remember the group youre in
				mo.LTB_zipid = pmo.LTB_zipid //remember the id, the point you touched
				mo.LTB_zip = pmo.LTB_zip //the list of the group, to make thngs easier
				mo.LTB_disttonext = pmo.LTB_disttonext
				LTB_ziplines.funcs.calculateziplinedata(pmo.LTB_origin, pmo.LTB_dest, mo) //this function takes the point that got touched, the next and the object
				mo.LTB_zipprogress = pmo.LTB_zipprogress + FixedDiv(pmo.radius + mo.radius + 2 + pmo.LTB_zipspeed, pmo.LTB_disttonext)
				mo.angle = mo.LTB_ziphoriang
				mo.dir = mo.LTB_ziphoriang
				mo.movedir = mo.LTB_ziphoriang
				mo.LTB_throwhooked = true //do not let this happen again for the same thrown object
				mo.LTB_zipcooldown = 0 //dont add the coldown so it switch instantly if it needs to
				
				
			end
			if angbackdiff <= 42 then
				mo.LTB_inzipline = true //start the zipline action
				mo.LTB_zipgroup = pmo.LTB_zipgroup //remember the group youre in
				mo.LTB_zipid = pmo.LTB_zipid //remember the id, the point you touched
				mo.LTB_zip = pmo.LTB_zip //the list of the group, to make thngs easier
				mo.LTB_disttonext = pmo.LTB_disttonext
				LTB_ziplines.funcs.calculateziplinedata(pmo.LTB_origin, pmo.LTB_dest, mo) //this function takes the point that got touched, the next and the object
				mo.LTB_zipprogress = pmo.LTB_zipprogress - FixedDiv(pmo.radius + mo.radius + 1 + abs( pmo.LTB_zipspeed), pmo.LTB_disttonext)
				mo.angle = mo.LTB_ziphoriang
				mo.dir = mo.LTB_ziphoriang
				mo.movedir = mo.LTB_ziphoriang
				if mo.LTB_zipspeed > 0 then mo.LTB_zipspeed = $ *-1 end
				mo.LTB_throwhooked = true
				mo.LTB_zipcooldown = 0 //dont add the coldown so it switch instantly if it needs to
			end
		end
	end
end
function setzipfunc(a, b, mo)
	local objectspeed, horizontalangle, verticalangle, horizontaldist, gravityforce
	horizontaldist = FixedHypot(a.x - b.x, a.y - b.y)
	objectspeed = min(max(FixedHypot(mo.momx, mo.momy) or abs(mo.momz), ziplineminspeed),ziplinemaxspeed) //use some limiters here
	horizontalangle = R_PointToAngle2(a.x, a.y, b.x, b.y)
	verticalangle = R_PointToAngle2(0,0, horizontaldist, b.z - a.z)
	gravityforce = FixedMul(-P_GetMobjGravity(mo)/2, sin(verticalangle)) //using object gravity to keep conssitency with the rest of the game

	//if mo.type == MT_RANDOMITEMBOX then objectspeed = 22 * FRACUNIT end
	mo.LTB_ziphoriang = horizontalangle //zipline horizontal angle between the latest and next point, to be used to move the oobject
	mo.LTB_zipgravity = gravityforce //make it slow down of speed up, depends if going up or down
	mo.LTB_zipspeed = $ or objectspeed //keep previous speed ir any
	mo.LTB_zipprogress = 0 //mo.LTB_zipspeed //how far we are from the lastest point, ifswitching from another point, use the previous speed
	mo.LTB_origin = a //the lastest point we reached
	mo.LTB_dest = b //self explanatory
	mo.LTB_zipvertang = verticalangle //vertical angle between the latest point and the next one, to move the object TODO: FIX THAT, I ALMOST LOSE MY MIND BECAUSE OF IT, IT IS A LITTLE OFF BUT I DONT KNOW WHY
	mo.TLB_nogravityforce = nil
	if a.flags & 1 then //MFE_EXTRA
		//constant speed, no losing or getting extra speed
		mo.TLB_nogravityforce = true
	end
	if mo.TLB_nogravityforce then
		mo.LTB_zipgravity = 0
	end
	
	mo.LTB_verticaloffset = min(P_MobjFlip(mo)*mo.height, 0)
	if a.flags & 8 then --ambush
		mo.LTB_verticaloffset = $ + mo.height *-P_MobjFlip(mo) + ziplineverticaloffset*-P_MobjFlip(mo)
	end
	
	finishpogospring = 0
	if a.flags & 4 then --especial
		finishpogospring = 1 + min(a.opt.extrainfo,1)
	end
	
end


//addHook("LinedefExecute", linedefcustom, "zplnstspds")

//resets whatever
function stuffreset(m)
	ziplist = {} 
	alreadydrawn = nil
	ziplineminspeed = 16*FRACUNIT
	ziplinemaxspeed = 45*FRACUNIT
	ziplineverticaloffset = 0
	ziplinecolor = 0
	finishpogospring = 0
	dontconnect = nil
	zipbackenterrange, zipfrontenterrange = 45, 75
	hastobeonground = nil
	onlyentersides = nil
	objlistbackup = nil
	
	LTB_ziplines.ziplinelist = {}
	
	for p in players.iterate do
		if (p and p.valid and p.mo and p.mo.valid) then
			p.mo.LTB_ziphoriang = nil 
			p.mo.LTB_zipgravity = nil 
			p.mo.LTB_zipspeed = nil 
			p.mo.LTB_zipprogress = nil 
			p.mo.LTB_origin = nil 
			p.mo.LTB_dest = nil 
			p.mo.LTB_zipvertang = nil 
			p.mo.TLB_nogravityforce = nil
			p.mo.LTB_zipgravity = nil
			p.mo.LTB_verticaloffset = nil
			p.mo.LTB_inzipline = nil
			p.mo.LTB_oldangle = nil
			p.mo.LTB_targetangle = nil
			p.mo.LTB_angleturnspeed = nil
			p.mo.LTB_angleturn = nil
		else continue end
	end
end



//addHook("MapChange",stuffreset)

/*
	Zipline created by Lighto
	a dynamic zipline code that lets you create a path that objects (yes, objects) can travel to point a to b (or opposite)
	you just have to add the points on your map
	
	it simplily uses the objects angle 
	and its separated between groups and points
	
	each group is a angle, every 359, so 0 - 359 is group 1, 360 to 719  is group 2 and on
	betwen those values, each single number representes a point
	so 1 is the ifrst point of group 1, 2 is the second point of group 2
	360 is the first point of group 2, 361 is the second point of group 2
	dont worry, its easy when you get the hang of things
	
*/

//transfer momentum to another object
function momentumtransfer(mo, mo2)
	local mospeed,momoveangle,moscale,mo2speed,mo2moveangle,mo2scale = mo.LTB_zipspeed or FixedHypot(mo.momx, mo.momy), R_PointToAngle2(0,0,mo.momx, mo.momy),mo.radius + mo.height,mo2.LTB_zipspeed or FixedHypot(mo2.momx, mo2.momy), R_PointToAngle2(0,0,mo2.momx, mo2.momy),mo2.radius + mo2.height
	local finalspeed, finalscale = abs(mospeed - mo2speed), abs(moscale - mo2scale)
	local fasterspeed, higherscale = mo2speed, mo2scale
	if mospeed > mo2speed then fasterspeed = mospeed end
	if moscale > mo2scale then higherscale = moscale end
	//print("size diff "..(moscale - mo2scale))
	//print("finalspeed "..FixedInt(FixedMul(abs(mospeed - mo2speed), moscale - mo2scale)))
	local finapspeed1, finalspeed2 = FixedDiv(abs(mospeed - mo2speed) or (8*FRACUNIT), (moscale - mo2scale) or (12*FRACUNIT)), FixedMul(abs(mospeed - mo2speed)   or (8*FRACUNIT), (mo2scale - moscale) or (12*FRACUNIT))

	if mo.LTB_inzipline then
		mo.LTB_zipspeed = ($ or 0) + finapspeed1
	else
		P_Thrust(mo, momoveangle, finapspeed1)
	end
	if mo2.LTB_inzipline then
		mo2.LTB_zipspeed = ($ or 0) + finalspeed2
	else
		P_Thrust(mo2, mo2moveangle, finalspeed2)
	end
end

//make obejcts trasnfer momentum o nthew zipline uppon collision
function ziplinecollide(mo, moving)
	if not(mo and mo.valid) or not(moving and moving.valid) then return nil end
	if mo.z > moving.height+moving.z then return false end
	if moving.z > mo.height+mo.z then return false end
	if mo.flags & MF_MONITOR or moving.flags & MF_MONITOR then return nil end
	if not mo.LTB_inzipline then return nil end
	if mo.LTB_bumpcooldown or moving.LTB_bumpcooldown then return nil end
	local mospeed, movingspeed, momoveangle, movingmoveangle, angledifference, finalspeed, winnerspeed
	mospeed = mo.LTB_zipspeed
	movingspeed = FixedHypot(moving.momx, moving.momy) or moving.LTB_zipspeed or 16*FRACUNIT
	local isshootable= nil
	if mo.flags & MF_SHOOTABLE and not(mo.flags & MF_SOLID) then isshootable = true end
	local othershootable = nil
	if moving.flags & MF_SHOOTABLE and not(moving.flags & MF_SOLID) then othershootable = true end
	
	local moghzball, otherghzball
	if moghzball then
		if mo.type == MT_GHZBALL then ghzball = true end
		if moving.type == MT_GHZBALL then otherghzball = true end		
		
		
		//special checker werecker cases
		if moghzball or otherghzball then
			if not(moghzball and otherghzball) then //only one of them is a checker werecker
				local finalghzball, finalother 
				finalother = moving
				if moghzball then finalghzball = mo  elseif otherghzball then finalghzball = moving  end
				if mo.flags & MF_SHOOTABLE and not(mo.flags & MF_SOLID) then finalother = mo elseif moving.flags & MF_SHOOTABLE and not(moving.flags & MF_SOLID) then finalother = moving end
				
				if not(finalghzball.type == MT_BANANA or finalother.type == MT_BANANA or finalghzball.type == MT_BANANA_SHIELD or finalother.type == MT_BANANA_SHIELD) and (finalghzball.flags & MF_SOLID or finalother.flags & MF_SOLID) and not finalghzball.finalghzball then
					LTB_ziplines.funcs.ziplinetrasnfermomentum(finalghzball, finalother)
				end
				finalghzball.ballcollidedtimer = 10 
				if finalother.flags & MF_SHOOTABLE and not(finalother.flags & MF_SOLID) then
					S_StartSound(finalother, finalother.info.deathsound)
					P_KillMobj(finalother, finalghzball, finalghzball.target)
				end
				finalghzball.LTB_bumpcooldown = TICRATE/6
				finalghzball.ballcollidedtimer = 10 
				return false 
			else
				//ported from checker wrecker code, both are checker wrecker
				if not (mo.ballcollidedtimer or moving.ballcollidedtimer) or mo.ballcollided ~= moving and (mo.ballcollidedtimer or 0) < 4 then //dont bounce multiple times
					LTB_ziplines.funcs.ziplinetrasnfermomentum(mo, moving)
					mo.ballcollidedtimer = 10 
					moving.ballcollidedtimer = 10 
					mo.LTB_bumpcooldown = TICRATE/6
					moving.LTB_bumpcooldown = TICRATE/6
					mo.LTB_bumpcooldown = TICRATE/6
					moving.LTB_bumpcooldown = TICRATE/6
					return false
				end
				
			end
		end	
	else
		//ONLY SOLIDS. not suporting EVERY POSSIBLE INSTANCE OF OBEJCTS
		if mo.flags & MF_SOLID and not (mo.flags & MF_SCENERY)
		and moving.flags & MF_SOLID and not (moving.flags & MF_SCENERY) then
			LTB_ziplines.funcs.ziplinetrasnfermomentum(mo, moving)
			mo.LTB_bumpcooldown = TICRATE/6
			moving.LTB_bumpcooldown = TICRATE/6
			return false
		end
		if mo.flags & MF_SCENERY or moving.flags & MF_SCENERY then
			//mo.LTB_bumpcooldown = TICRATE/6
			//moving.LTB_bumpcooldown = TICRATE/6
			
			return true
		end
	end
	
	mo.LTB_bumpcooldown = TICRATE/6
	moving.LTB_bumpcooldown = TICRATE/6
	return false
end

function playerzipdamage( player,  inflictor,  source)
	if not (player.mo and player.mo.valid) then return false end
	if not player.mo.LTB_inzipline then return false end
	local damagespeed, scalediff = 22*FRACUNIT, 16*FRACUNIT
	if inflictor and inflictor.valid then
		damagespeed = FixedHypot(inflictor.momx, inflictor.momy)
		scalediff = (player.mo.radius + player.mo.height) - (inflictor.radius + inflictor.height)
	end
	//if player is going to get spun, add the object mass to its speed
	
	player.mo.LTB_zipspeed = $ + abs(FixedDiv(damagespeed, scalediff))
	return false

end


function playerziplinesquish( player,  inflictor,  source)
	if not (player.mo and player.mo.valid) then return false end
	if not player.mo.LTB_inzipline then return false end
	local scaledif = 12*FRACUNIT
	if inflictor and inflictor.valid then
		scaledif = (player.mo.radius + player.mo.height) - (inflictor.radius + inflictor.height)
	end
	local curspeed = player.mo.LTB_zipspeed or 12*FRACUNIT
	player.mo.LTB_zipspeed = $ - (FixedDiv(curspeed, scaledif))
	return false
end


function playerziplineexplode( player,  inflictor,  source)
	if not (player.mo and player.mo.valid) then return false end
	if not player.mo.LTB_inzipline then return false end

	//it can explode, but wont move vertically it will give extreme zipline speed for... funnies
	player.mo.zmom = 0
	player.mo.LTB_zipspeed = $ * 8
	return false
end


function ziplinewind(mo)
	local sec,spec,line = P_ThingOnSpecial3DFloor(mo)
	if sec then
		spec = GetSecSpecial(sec.special,3)
		line = lines[P_FindSpecialLineFromTag(542, sec.tag,-1)] --up
		
		if spec == 2 and line then
		
			mo.LTB_zipspeed = $ + FixedHypot(line.dx, line.dy)/5
		end
		line = lines[P_FindSpecialLineFromTag(543, sec.tag,-1)] --down
		if spec == 2 and line then
		
			mo.LTB_zipspeed = $ - FixedHypot(line.dx, line.dy) /5
		end
	end
end


local localversion = 1
local localrevision = 3
if not LTB_ziplines then
	print("Zipline - written by Lighto")
	print("setting up Zipline lib data")
	rawset(_G, "LTB_ziplines", {}) //ayo
	LTB_ziplines.version = localversion
	LTB_ziplines.revision = localrevision
	LTB_ziplines.ziplinelist = ziplist
	LTB_ziplines.objectlist = {} --it uses this list to tackle which obejcts should be processed
	LTB_ziplines.funcs = {}
	LTB_ziplines.funcs.calculateziplinedata = setzipfunc 
	LTB_ziplines.funcs.makeziplinelist = buildziplinetable
	LTB_ziplines.funcs.createziplinesegments = ziplinelinedraw
	LTB_ziplines.funcs.lookforziplines = lookzipline
	LTB_ziplines.funcs.antilockfunctions = safetychecks
	LTB_ziplines.funcs.itemzipthrow = itemthroeinteract
	LTB_ziplines.funcs.ziplinetriggerfunc = linedefcustom
	LTB_ziplines.funcs.ziplinelogicfunction = ziplinelogic
	LTB_ziplines.funcs.resetstuff = stuffreset
	LTB_ziplines.funcs.exitzipline = exitzipline
	LTB_ziplines.funcs.ziplinewindinteract = ziplinewind
	LTB_ziplines.funcs.ziplinecollide = ziplinecollide
	LTB_ziplines.funcs.playerziplinespin = playerzipdamage
	LTB_ziplines.funcs.playerziplineexplode = playerziplineexplode
	LTB_ziplines.funcs.playerziplinesquish = playerziplinesquish
	LTB_ziplines.funcs.enterzipline = enterzipline
	LTB_ziplines.funcs.setangleinterpolation = setanglelerp
	LTB_ziplines.funcs.ziplinetrasnfermomentum = momentumtransfer
	
	//adding things to the list
	//vanilla items
	table.insert(LTB_ziplines.objectlist, MT_PLAYER)
	table.insert(LTB_ziplines.objectlist, MT_JAWZ)
	table.insert(LTB_ziplines.objectlist, MT_ORBINAUT)
	table.insert(LTB_ziplines.objectlist, MT_EGGMANITEM) //yes, why not, if this somehow is conceived
	//checker wrecker
	if ghzball then table.insert(LTB_ziplines.objectlist, MT_GHZBALL) end
	
	//community resources custom item boxes
	if dynamicitems_initialized then table.insert(LTB_ziplines.objectlist, MT_RANDOMITEMBOX) end
	
	//minecarts
	if minecarts_initialized then table.insert(LTB_ziplines.objectlist, MT_MINECART) end
	
	//empty kart
	if emptykarts_initialized then table.insert(LTB_ziplines.objectlist, MT_EMPTYKART)  end
	objlistbackup = LTB_ziplines.objectlist
	//reset variables on map change
	addHook("MapChange",LTB_ziplines.funcs.resetstuff)
	
	
	//set those vars if ever desired by the mapper
	//currently, only setting minimum speed and maximum speed
	addHook("LinedefExecute", LTB_ziplines.funcs.ziplinetriggerfunc, "zplnstspds")

	
	//first build the list we wanna use
	addHook("MobjThinker",function(mo)
		LTB_ziplines.funcs.makeziplinelist(mo)
	end, MT_ZIPLINE)
	//LTB_ziplines.ziplinelist = ziplist
	
	
	//right after, draw the segments
	addHook("ThinkFrame",LTB_ziplines.funcs.createziplinesegments)
	
	
	//NOWS THE BIG THING, MOST IMPROTANT
	//process each object of the object list
	for k,v in pairs(LTB_ziplines.objectlist) do
		if not LTB_ziplines.ziplinelist then return end
		if not mobjinfo[v] then continue end --extra paranoia layer, skip this obejcts if not defined
		
		addHook("MobjThinker",function(mo)
			if not(mo and mo.valid) then return end //paranoia season 2
			local objhspeed = FixedHypot(mo.momx ,mo.momy) 
			if objhspeed < 8*FRACUNIT then objhspeed = abs(mo.momz) end
			if not mo.LTB_inzipline and not mo.LTB_zipcooldown
			and objhspeed >= 8*FRACUNIT 
			and (not hastobeonground or (hastobeonground and P_IsObjectOnGround(mo)))then 
				LTB_ziplines.funcs.lookforziplines(mo)
			end
				
			
			if mo.LTB_inzipline then
				LTB_ziplines.funcs.ziplinewindinteract(mo)
				LTB_ziplines.funcs.ziplinelogicfunction(mo)
				if mo.eflags & MFE_SPRUNG then LTB_ziplines.funcs.exitzipline(mo) end
				if mo.type == MT_PLAYER and mo.player.kartstuff[k_dashpadcooldown] > 0 then LTB_ziplines.funcs.exitzipline(mo) end
				if mo.dashpadcooldown and mo.dashpadcooldown > 0 then LTB_ziplines.funcs.exitzipline(mo) end
			end
			
			//always decrease this
			mo.LTB_zipcooldown = max(0, ($ or 0) -1)
			mo.LTB_bumpcooldown = max(0, ($ or 0) -1)
			
			//save you from being stuck in a pont or goint back and forth
			//first it gives you a speed boost for the way you moving
			//if you fall again, it gives a forward boost
			LTB_ziplines.funcs.antilockfunctions(mo)
			
			//special for any other thing thats not ap layer
			//to know for howl ong it exists
			if mo.type ~= MT_PLAYER then
				mo.LTB_otherslife = ($ or 0) + 1
			end
			
			//specific items interactions goes here
			LTB_ziplines.funcs.itemzipthrow(mo)
			
			
		end, v)
		
		addHook("MobjCollide",LTB_ziplines.funcs.ziplinecollide,v)

	end
	addHook("PlayerSpin", LTB_ziplines.funcs.playerziplinespin)
	addHook("PlayerExplode", LTB_ziplines.funcs.playerziplineexplode)
	addHook("PlayerSquish", LTB_ziplines.funcs.playerziplinesquish)
	
	
	print("all set!")

end

if LTB_ziplines.version < localversion or ( LTB_ziplines.version == localversion and LTB_ziplines.revision < localrevision) then
	print("newer version detected, updating libraries")
		
	LTB_ziplines.version = localversion
	LTB_ziplines.revision = localrevision
	LTB_ziplines.ziplinelist = ziplist
	LTB_ziplines.objectlist = objlistbackup --it uses this list to tackle which obejcts should be processed
	LTB_ziplines.funcs = {}
	LTB_ziplines.funcs.calculateziplinedata = setzipfunc 
	LTB_ziplines.funcs.makeziplinelist = buildziplinetable
	LTB_ziplines.funcs.createziplinesegments = ziplinelinedraw
	LTB_ziplines.funcs.lookforziplines = lookzipline
	LTB_ziplines.funcs.antilockfunctions = safetychecks
	LTB_ziplines.funcs.itemzipthrow = itemthroeinteract
	LTB_ziplines.funcs.ziplinetriggerfunc = linedefcustom
	LTB_ziplines.funcs.ziplinelogicfunction = ziplinelogic
	LTB_ziplines.funcs.resetstuff = stuffreset
	LTB_ziplines.funcs.exitzipline = exitzipline
	LTB_ziplines.funcs.ziplinewindinteract = ziplinewind
	LTB_ziplines.funcs.ziplinecollide = ziplinecollide
	LTB_ziplines.funcs.playerziplinespin = playerzipdamage
	LTB_ziplines.funcs.playerziplineexplode = playerziplineexplode
	LTB_ziplines.funcs.playerziplinesquish = playerziplinesquish
	LTB_ziplines.funcs.enterzipline = enterzipline
	LTB_ziplines.funcs.setangleinterpolation = setanglelerp
	LTB_ziplines.funcs.ziplinetrasnfermomentum = momentumtransfer
	
	print("everything up to date!")
end
